<template>
	<xn-form-container
		:title="formData.id ? '编辑预约时段配置' : '增加预约时段配置'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :wrapper-col="wrapperCol" :label-col="labelCol">
			<a-form-item label="开始时段：" name="beginTime">
<!--				<a-input v-model:value="formData.beginTime" placeholder="请输入开始时段" allow-clear />-->
				<a-time-picker v-model:value="formData.beginTime" valueFormat="HH:mm" format = "HH:mm"  placeholder="请选择预约开始时间段" style="width: 100%" />
			</a-form-item>
			<a-form-item label="结束时段：" name="endTime">
				<a-time-picker v-model:value="formData.endTime" valueFormat="HH:mm" format = "HH:mm"  placeholder="请选择预约结束时间段" style="width: 100%" />
			</a-form-item>
			<a-form-item label="申请数量：" name="applyNumber">
				<a-input-number v-model:value="formData.applyNumber" style="width:90%"  :precision="0" :min="1" :max="99999" placeholder="请输入申请数量" allow-clear /><span style="margin-left:10px;">次</span>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="bizAppointmentTimeForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import bizAppointmentTimeApi from '@/api/biz/bizAppointmentTimeApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	//设置表单样式
	const labelCol = ref({ span: 5})
	const wrapperCol = ref({ span: 16})

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		beginTime: [required('请输入开始时段')],
		endTime: [required('请输入结束时段')],
		applyNumber: [required('请输入申请数量')],
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				bizAppointmentTimeApi
					.bizAppointmentTimeSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
